	page	,132
;
;UNLOAD------Kantronics, Inc. 15 Sep 84
;unload converts a binary file, usually a .COM file,
;to a text type .HEX file which can be transmitted over the air
;unload assumes the binary file starts at memory location 100H
;
;error checking is at a minimum
makef	equ	016h
wrtf	equ	015h
closf	equ	010h
readf	equ	014h
openf	equ	0fh
code	segment
	assume	cs:code,ds:code,es:code
	org	05ch
fcb1	db	?
	org	080h
buff1	db	?
	org	0100h
begin:	cld
	mov	si,offset fcb1
	mov	di,offset fcb2
	mov	cx,9
	rep movsb	;move filenam to fcb2
	mov	ah,openf	;open input file
	mov	dx,offset fcb1
	int	021h
	and	al,al
	jz	open2
	mov	ah,9
	mov	dx,offset error1
	int	021h
	int	020h
open2:	mov	fcb1+32,al
	mov	ah,makef	;create output file (.HEX)
	mov	dx,offset fcb2
	int	021h
	mov	byte ptr fcb2+32,0
	mov	addr,0100h	;initialize pointers
	mov	point1,offset buff1+127
	mov	point2,offset buff2
main:	mov	al,':'	;start of hex record
	call	writeb
	mov	byte ptr check,0	;clear checksum
	mov	al,16	;number of bytes
	call	writeh
	mov	al,byte ptr addr+1	;address
	call	writeh
	mov	al,byte ptr addr
	call	writeh
	mov	al,0	;toss in a zero
	call	writeh
	mov	cx,16
loop:	call	getb	;get binary byte from input file
	jz	mainx	;jump if end of file
	call	writeh	;write byte as two hex digits
	inc	addr
	loop	loop
	mov	al,check	;write negative checksum
	neg	al
	call	writeh
	call	crlf	;CRLF ends hex record
	jmp	main
mainx:	mov	al,0	;finish hex record with zeroes
	call	writeh
	loop	mainx
	mov	al,check
	neg	al
	call	writeh
	call	crlf
	mov	al,':'	;start last hex record
	call	writeb
	mov	cx,10
mainy:	mov	al,'0'	;byte count = 0 means last record
	call	writeb
	loop	mainy
	call	crlf
	mov	al,01ah	;write ctrl-z to indicate end of text file
mainz:	call	writeb
	mov	al,0	;fill buffer with zeroes and write it out
	cmp	point2,offset buff2
	jnz	mainz
	mov	ah,closf	;close output .HEX file
	mov	dx,offset fcb2
	int	021h
	int	020h	;end program
;
writeh:	push	ax	;write binary byte as two hex digits
	add	byte ptr check,al
	ror	al,1
	ror	al,1
	ror	al,1
	ror	al,1
	call	writen
	pop	ax
writen:	and	al,0fh
	or	al,'0'
	cmp	al,'9'
	jbe	writeb
	add	al,7
writeb:	mov	di,point2	;put character in output buffer
	mov	byte ptr [di],al
	inc	di
	cmp	di,offset buff2+080h
	jnz	wrtx
	mov	dx,offset buff2	;if buffer full, write it to disk
	mov	ah,01ah	;set dma address to buffer 2
	int	021h
	mov	dx,offset fcb2	;write buffer2 to disk
	mov	ah,wrtf
	int	021h
	mov	dx,080h	;reset dma address to input buffer
	mov	ah,01ah
	int	021h
	mov	di,offset buff2
wrtx:	mov	point2,di
	ret
;
getb:	mov	di,point1	;get byte from input buffer
	inc	di
	cmp	di,offset buff1+128
	jnz	getbx
	mov	ah,readf	;if buffer empty, read in 128 bytes
	mov	dx,offset fcb1
	int	021h
	mov	di,offset buff1
	cmp	al,1
	jz	getbz
getbx:	mov	al,[di]
	mov	point1,di
getbz:	ret
;
crlf:	mov	al,0dh	;write carriage return/line feed to output file
	call	writeb
	mov	al,0ah
	jmp	writeb
;
error1	db	'file not found$'
;
addr	dw	?
point1	dw	?
point2	dw	?
check	db	?
;
fcb2	db	9 dup(?)
	db	'HEX'
	db	24 dup(0)
buff2	db	128 dup (0)
;
code	ends
	end	begin
